//-----------------------------------------------------------
// smpl4(us0_dx).c
// US0ɂ锼dVAʐM
//   Copyright (c) BestTechnology CO.,LTD. 2005-2010
//-----------------------------------------------------------
// US0DynamixelƃVAʐMsB
// AX-12+̃ftHgz肵Ă邽߃{[[g1MbpsA
// ID1z肵ĂB
//-----------------------------------------------------------

#include <stdlib.h>

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>
#include <us.h>

#define __UDP__   // US0͎w肵Ȃ
#include "share/us.c"

// US0pMobt@
static char us0tbuf[500], us0rbuf[500];
// DXvgR̃CXgNV
typedef enum {INST_PING=1, INST_READ=2, INST_WRITE=3, INST_REG_WRITE=4, INST_ACTION=5, INST_RESET=6, INST_SYNC_WRITE=0x83, INST_SYNG_REG_WRITE=0x85} TInstruction;
// DXvgR̃Xe[^XpPbgM\oCg
int DX_RxLen = 0;

#define BROADCASTING_ID           0xfe

#define ADDRESS_GOAL_POSITION     30
#define ADDRESS_TORQUE_LIMIT      34
#define ADDRESS_PRESENT_POSITION  36
#define ADDRESS_LED               25

#define _DX_WRITE_RESPONSE_TIME   50
#define _DX_READ_RESPONSE_TIME    50

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// UART0
//========================================================
void Init_US0 (int baud) {
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
  TPin rtspin[] = {
    {1 << 8, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},  // PA8 -> RTS0
  };
#else
  TPin rtspin[] = {
    {1 << 7, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},  // PA7 -> RTS0
  };
#endif

  // pdcɂUS0𐧌  TXD0RXD0[q
  us0_pdc_init (baud, us0tbuf, sizeof(us0tbuf), us0rbuf, sizeof(us0rbuf));
  // Dynamixel͔dʐMƂȂ邽߁AUS0RS485[hRTS0[qǉŊ
  USART0.MR |= _US_USMODE_RS485;
  PIO_Configure (rtspin, PIO_LISTSIZE (rtspin));
}

// DXpPbgM
uint8_t DX_TxPacket (uint8_t *txdata, uint8_t ID, TInstruction Inst, uint8_t *param, int len) {
  volatile uint8_t i, SUM;
  char buf[300];

  if ((ID > 0xfe) || (len > 120)) return 0;

  while (us0_pdc_tx_buff ()) ;

  buf[0] = buf[1] = 0xff;
  SUM = (buf[2] = ID);
  SUM += (buf[3] = (uint8_t)(len + 2));
  SUM += (buf[4] = (uint8_t)Inst);
  for (i = 0; i < len; i++) SUM += (buf[i + 5] = param[i]);
  buf[len + 5] = ~SUM;
  if (txdata != NULL) for (i = 0; i < len + 6; i++) txdata[i] = buf[i];

  switch (Inst) {
    case INST_PING:
      if (ID == 0xFE)  DX_RxLen = 0;
      else DX_RxLen = 6;
      break;
    case INST_READ:
      if (ID == 0xFE)  DX_RxLen = 0;
      else DX_RxLen = 6 + param[1];
      break;
    case INST_WRITE:
      if (ID == 0xFE)  DX_RxLen = 0;
      else DX_RxLen = 6;
      break;
    case INST_REG_WRITE:
      if (ID == 0xFE)  DX_RxLen = 0;
      else DX_RxLen = 6;
      break;
    case INST_ACTION:
      DX_RxLen = 0;
      break;
    case INST_RESET:
      if (ID == 0xFE)  DX_RxLen = 0;
      else DX_RxLen = 6;
      break;
    case INST_SYNC_WRITE:
      DX_RxLen = 0;
      break;
    case INST_SYNG_REG_WRITE:
      DX_RxLen = 0;
      break;
  }
  us0_pdc_sys_puts (buf, len + 6);

  return len + 4 + 2;
}

// DXpPbgM
int DX_RxPacket (uint8_t *rxdata, int *len, uint16_t timeout) {
#define _PAUSE1MS  33
  volatile uint8_t  sum = 0;
  int               i, j, l = 0;
  volatile int      result = 0;
  char buf[300];

  if (DX_RxLen >= 6) {
    RTT.MR = _RTT_RTTRST;
    while (RTT.SR & _RTT_ALMS) ;
    RTT.AR = timeout;
    RTT.MR = _RTT_RTTRST | _PAUSE1MS; // Configure the RTT:

    // ЂƂ܂wb_̎M҂
    while ((us0_pdc_rx_buff () != 5) && ((RTT.SR & _RTT_ALMS) == 0)) ;
    // ^CAEgĂȂ
    if (us0_pdc_rx_buff () >= 5) {
      for (i = 0; i < 5; i++) buf[i] = us0_pdc_getc ();
      // wb_̊mF
      if ((buf[0] == 0xff) && (buf[1] == 0xff) && (buf[2] <= 0xfe) && (buf[3] <= 120)) {
        sum = buf[2] + buf[3] + buf[4];
        l = 5;
        // Xe[^XpPbg6oCgɂȂG[vmF
        if ((buf[4] & 0b01011010)) {
          while ((us0_pdc_rx_buff () < 1) && ((RTT.SR & _RTT_ALMS) == 0)) ;
          j = us0_pdc_rx_buff ();
          for (i = 0; i < j; i++) buf[5 + i] = us0_pdc_getc ();
          // `FbNTmF
          for (i = 0; i < j - 1; i++) sum += buf[l + i];
          l += 5 + j;
          if (((~sum) & 0xff) == buf[l - 1]) result = l;
        // ʏ̉
        } else {
          while ((us0_pdc_rx_buff () != (DX_RxLen - 5)) && ((RTT.SR & _RTT_ALMS) == 0)) ;
          j = us0_pdc_rx_buff ();
          for (i = 0; i < j; i++) buf[5 + i] = us0_pdc_getc ();
          if (us0_pdc_rx_buff () == 0) {
            for (i = l; i < DX_RxLen - 1; i++) sum += buf[i];
            l = DX_RxLen;
            if (((~sum) & 0xff) == buf[DX_RxLen - 1]) result = l;
          } else
            l = DX_RxLen + us0_pdc_rx_buff ();
        }
      }
    }
  }
  // KvɉĎwobt@ɃRs[
  if (rxdata != NULL) for (i = 0; i < l; i++) *rxdata++ = buf[i];
  if (len != NULL) *len = l;

  return result;
}

// oCgf[^擾
bool DX_ReadByteData (uint8_t id, uint8_t adr, uint8_t *result) {
  int l1;
  uint8_t param[10];
  uint8_t rbuf[20];

  if (id != BROADCASTING_ID) {
    param[0] = adr;
    param[1] = 1;
    DX_TxPacket (NULL, id, INST_READ, param, 2);
    if (DX_RxPacket (rbuf, &l1, _DX_READ_RESPONSE_TIME) > 0) {
      *result = rbuf[5];
      return true;
    }
  }
  return false;
}

// [hf[^擾
bool DX_ReadWordData (uint8_t id, uint8_t adr, uint16_t *result) {
  int l1;
  uint8_t param[10];
  uint8_t rbuf[20];
  if (id != BROADCASTING_ID) {
    param[0] = adr;
    param[1] = 2;
    DX_TxPacket (NULL, id, INST_READ, param, 2);
    if (DX_RxPacket (rbuf, &l1, _DX_READ_RESPONSE_TIME) > 0) {
      *result = rbuf[5] + (rbuf[6] << 8);
      return true;
    }
  }
  return false;
}

// oCgf[^
bool DX_WriteByteData (uint8_t id, uint8_t adr, uint8_t dat) {
  int l1;
  uint8_t param[10];
  uint8_t rbuf[20];

  param[0] = adr;
  param[1] = dat;
  DX_TxPacket (NULL, id, INST_WRITE, param, 2);
  if (id != BROADCASTING_ID) return (DX_RxPacket (rbuf, &l1, _DX_READ_RESPONSE_TIME) > 0);
  else return true;
}

// [hf[^
bool DX_WriteWordData (uint8_t id, uint8_t adr, uint16_t dat) {
  int l1;
  uint8_t param[10];
  uint8_t rbuf[20];

  param[0] = adr;
  param[1] = dat & 0xff;
  param[2] = dat >> 8;
  DX_TxPacket (NULL, id, INST_WRITE, param, 3);
  if (id != BROADCASTING_ID) return (DX_RxPacket (rbuf, &l1, _DX_READ_RESPONSE_TIME) > 0);
  else return true;
}

//========================================================
// main
//========================================================
void main (void) {

  enableIRQ();
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  // US0DynamixelpI/FƂď
  Init_US0 (1000000);

  wait (5000);

  uint16_t gpos = 0, ppos = 0;
  uint8_t led = 0;
  int dir = -1;

  // ݈ʒuǂݏo
  if (DX_ReadWordData(1, ADDRESS_PRESENT_POSITION, &ppos)) gpos = ppos; else _us_puts("read word error\n");
  // gN~bgႭݒ
  if (!DX_WriteWordData (1, ADDRESS_TORQUE_LIMIT, 256)) _us_puts("write byte error\n");

  while (1) {
    // ʒuw
    if (!DX_WriteWordData (1, ADDRESS_GOAL_POSITION, gpos)) _us_puts("write word error\n");
    // ݈ʒuǂݏo
    if (!DX_ReadWordData (1, ADDRESS_PRESENT_POSITION, &ppos)) _us_puts("read word error\n");
    // LEDw
    if (!DX_WriteByteData (1, ADDRESS_LED, led)) _us_puts("write byte error\n");

    led ^= 1;

    gpos = gpos + dir;
    if (gpos >= 1023) { gpos = 1023; dir = -1; }
    else if (gpos <= 0) { gpos = 0; dir = 1; }
  }
}
