//-----------------------------------------------------------
// smpl2(pio2).c
// PIO荞
//   Copyright (c) BestTechnology CO.,LTD. 2005-2010
//-----------------------------------------------------------
// vbVXCb`̏Ԃ荞݂őȀԂɉ
// LED𖾖ŁB
// *PA0,PA1,PA2,PA29LEDVNڑ
// *PA17,PA18,PA19,PA20ɃvbVXCb`GND֐ڑ
//-----------------------------------------------------------

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif
// PIOȈՏ֘Awb_
#include <piocfg.h>
// 荞݊֘Awb_
#include <vic.h>

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#define _LED1 ((uint32_t)1 << 19) // PB19 -> LED1
#define _LED2 ((uint32_t)1 << 20) // PB20 -> LED2
#define _LED3 ((uint32_t)1 << 21) // PB21 -> LED3
#define _LED4 ((uint32_t)1 << 22) // PB22 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#define _PB1  ((uint32_t)1 << 21) // PA21 -> PB1
#define _PB2  ((uint32_t)1 << 22) // PA22 -> PB2
#define _PB3  ((uint32_t)1 << 23) // PA23 -> PB3
#define _PB4  ((uint32_t)1 << 24) // PA24 -> PB4
#define _ALL_PB  (_PB1 | _PB2 | _PB3 | _PB4)

static const TPin pins[] = {
  {_ALL_LED, &PIOB, PIOB_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  {_ALL_PB,  &PIOA, PIOA_PID, PIO_INPUT,    PIO_PULLUP },
};
#else
#define _LED1 ((uint32_t)1 << 0)  // PA0  -> LED1
#define _LED2 ((uint32_t)1 << 1)  // PA1  -> LED2
#define _LED3 ((uint32_t)1 << 2)  // PA2  -> LED3
#define _LED4 ((uint32_t)1 << 29) // PA29 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#define _PB1  ((uint32_t)1 << 17) // PA17 -> PB1
#define _PB2  ((uint32_t)1 << 18) // PA18 -> PB2
#define _PB3  ((uint32_t)1 << 19) // PA19 -> PB3
#define _PB4  ((uint32_t)1 << 20) // PA20 -> PB4
#define _ALL_PB  (_PB1 | _PB2 | _PB3 | _PB4)

static const TPin pins[] = {
  {_ALL_LED, &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  {_ALL_PB,  &PIOA, PIOA_PID, PIO_INPUT,    PIO_PULLUP },
};
#endif

//========================================================
// MISC...
//========================================================
// w[qHIGH
static __inline__ void PIOA_SetOutput (uint32_t d) {
  PIOA.SODR = d;
}

// w[qLOW
static __inline__ void PIOA_ClearOutput (uint32_t d) {
  PIOA.CODR = d;
}

//========================================================
// PIO
//========================================================
// PIO荞݃nh
void PIOA_irq_handler (void) {
  uint32_t isr = PIOA.ISR & PIOA.IMR; // ͕ω荞ݗv擾
  uint32_t pdsr = PIOA.PDSR;          // ͒[qԂ擾

  // 荞ݗvʂɕ
  if (isr & _PB1) {
    if (pdsr & _PB1) PIOA_ClearOutput (_LED1);
    else             PIOA_SetOutput (_LED1);
  }
  if (isr & _PB2) {
    if (pdsr & _PB2) PIOA_ClearOutput (_LED2);
    else             PIOA_SetOutput (_LED2);
  }
  if (isr & _PB3) {
    if (pdsr & _PB3) PIOA_ClearOutput (_LED3);
    else             PIOA_SetOutput (_LED3);
  }
  if (isr & _PB4) {
    if (pdsr & _PB4) PIOA_ClearOutput (_LED4);
    else             PIOA_SetOutput (_LED4);
  }
}

// PIO
void PIOA_Init (void) {
  // PIO Config
  PIO_Configure (pins, PIO_LISTSIZE (pins));

  // e[qɂ銄荞݋
  PIOA.IER = _PB1 | _PB2 | _PB3 | _PB4;

  // ЂƂ܂PIOA荞݂֎~
  AIC.IDCR = 1 << PIOA_PID;
  // AICɊ荞݃xN^ݒ
  AIC.SVR[PIOA_PID] = PIOA_irq_handler;
  AIC.SMR[PIOA_PID] = _AIC_SRCTYPE_INT_HIGH_LEVEL | _AIC_PRIOR_LOWEST;
  // PIOA荞݃NA
  AIC.ICCR = 1 << PIOA_PID;
  // PIOA荞݋
  AIC.IECR = 1 << PIOA_PID;
}

//========================================================
// main
//========================================================
void main (void) {
  enableIRQ ();

  PIOA_Init ();

  for (; ;) ;
}
